/* DIJKSTRA.C : tkeress Dijkstra mdszerrel */

#include <stdio.h>
#include <conio.h>

#define MaxPontDb 8                      /* A pontok maximlis szma */
#define MaxElDb MaxPontDb*(MaxPontDb-1)  /* Az lek maximlis szma */
#define MaxElHossz 99                    /* A maximlis lhossz */
#define NincsEl -1                       /* A nemltez l jelzsre */
#define MaxUtHossz MaxElDb*MaxElHossz    /* A maximlis thossz */
#define Vegtelen MaxUtHossz+1            /* A 'vgtelen' kezelshez */
#define KellKiiras 1                     /* Legyenek-e ellenrz kirsok */
#define NincsCimke -1                    /* A nemltez cmke jelzsre */

typedef struct {                         /* A pontrekord */
  char Azon;                             /* Pontazonost */
  int x,y;                               /* Koordintk */
} Pont;

/* Az leket egydimenzis tmbben troljuk */

typedef struct {                         /* Az lrekord */
  int Vp;                                /* Vgpontindex */
  int ElHossz;                           /* lhossz */
} El;

typedef struct {                         /* A grf */
  int PontDb;                            /* Pontok szma */
  Pont Pontok[MaxPontDb];                /* Pontok */
  int ElMut[MaxPontDb+1];                /* lmutatk */
  int ElDb;                              /* lek szma */
  El Elek[MaxElDb];                      /* lek */
} Graf;

typedef int Tomb[MaxPontDb];        /* Az egydimenzis tmbkhz (A,T,C) */

void GrafKiir(Graf *G)
{ int i,j,k;
  printf("Pontok szma:%d\n",(*G).PontDb);
  printf("Index Az-     X     Y\n");
  for (i=0; i<(*G).PontDb; i++)
    printf("%5d %c    %5d %5d\n",i+1,(*G).Pontok[i].Azon,
	   (*G).Pontok[i].x,(*G).Pontok[i].y);
  getch();
  printf("A grf lei:\n");
  for (i=0, k=1; i<(*G).PontDb; i++)
    for (j=(*G).ElMut[i]; j<(*G).ElMut[i+1]; j++, k++) {
      printf("%c - %c : %d\n",(*G).Pontok[i].Azon,
	(*G).Pontok[(*G).Elek[j].Vp].Azon,(*G).Elek[j].ElHossz);
      if (k%20==0) getch();
    }
  getch();
}

void AdatKiir(Graf *G, Tomb A, Tomb T, Tomb C, int ADb)
{ int i;
  printf("A:");
  for (i=0; i<ADb; i++)
    printf("%6c",(*G).Pontok[A[i]].Azon);
  printf("\nT:");
  for (i=0; i<(*G).PontDb; i++)
    if (T[i]==Vegtelen)
      printf("%6c",'-');
    else
      printf("%6d",T[i]);
  printf("\nC:");
  for (i=0; i<(*G).PontDb; i++)
    if (C[i]==NincsCimke)
      printf("%6c",' ');
    else
      printf("%6d",C[i]);
  printf("\n");
  getch();
}

void Dijkstra(Graf *G, Tomb T, Tomb C, int Kp)
{ Tomb A; int ADb;
  Tomb Akt;          /* A pontok aktvsga (1:aktv, 0:nem) */
  int x,y,i,j,k;
  /* Kezdllapot */
  for (i=0; i<(*G).PontDb; i++) {
    T[i]=Vegtelen;
    Akt[i]=0;
    C[i]=NincsCimke;   /* Csak a kirshoz kell */
  }
  T[Kp]=0;
  C[Kp]=Kp;
  ADb=1;
  A[ADb-1]=Kp;
  Akt[Kp]=1;
  if (KellKiiras) {
    printf("A kezdllapot\n");
    AdatKiir(G,A,T,C,ADb);
  }
  /* Javt lpsek */
  if (KellKiiras) j=0;       /* A javt lpsek szma */
  while (ADb>0) {
    /* Az A minimlis tvolsg elemt X-be */
    k=0;
    for (i=1; i<ADb; i++)
      if (T[A[i]]<T[A[k]]) k=i;
    x=A[k];
    /* X trlse A-bl (az utols elemmel fellrjuk) */
    A[k]=A[ADb-1];
    ADb=ADb-1;
    Akt[x]=0;
    /* Rvidts X-n keresztl */
    for (i=(*G).ElMut[x]; i<(*G).ElMut[x+1]; i++) {
      y=(*G).Elek[i].Vp;
      if (T[x]+(*G).Elek[i].ElHossz<T[y]) {
	T[y]=T[x]+(*G).Elek[i].ElHossz;
	C[y]=x;
	if (Akt[y]==0) {
	  /* Y mg nem aktv, hozzvesszk A-hoz */
	  ADb=ADb+1;
	  A[ADb-1]=y;
	  Akt[y]=1;
	}
      }
    }
    if (KellKiiras) {
      printf("%d. javt lps (x=%c) utn\n",++j,(*G).Pontok[x].Azon);
      AdatKiir(G,A,T,C,ADb);
    }
  }
}

void UtKiir(Graf *G, Tomb T, Tomb C, int Kp, int Vp)
{ Tomb Ut;      /* A Kp-Vp t pontindexei */
  int UtDb;     /* Az t pontjainak szma */
  int x,cs;
  printf("%c - %c viszonylat\n",(*G).Pontok[Kp].Azon,(*G).Pontok[Vp].Azon);
  if (T[Vp]==Vegtelen)
    printf("Nem lehet eljutni!\n");
  else {
    /* Az t sszeraksa (visszafel haladva) */
    UtDb=1;
    Ut[UtDb-1]=Vp;
    x=Vp;
    do {
      x=C[x];
      UtDb=UtDb+1;
      Ut[UtDb-1]=x;
    } while (x!=Kp);
    /* Az t megfordtsa */
    for (x=0; x<UtDb/2; x++) {
      cs=Ut[x]; Ut[x]=Ut[UtDb-x-1]; Ut[UtDb-x-1]=cs;
    }
    /* Az t kirsa */
    printf("A tvolsg:%d\n",T[Vp]);
    printf("Az t:");
    for (x=0; x<UtDb; x++)
      printf("%c ",(*G).Pontok[Ut[x]].Azon);
    printf("\n");
    getch();
  }
}

void main()
{ /* A pldagrf az leket egydimenzis tmbben trolva */
  Graf G = {8,{{'1',0,20},{'2',20,40},{'3',40,20},{'4',20,0},{'5',10,20},
	       {'6',20,30},{'7',30,20},{'8',20,10}},
	   {0,3,6,9,12,16,19,23,26},
	   26,{{1,40},{3,40},{4,10},{0,40},{2,40},{5,10},
	       {1,40},{3,40},{6,10},{0,40},{2,40},{7,10},
	       {0,10},{5,15},{6,20},{7,15},{1,10},{4,15},{6,15},
	       {2,10},{4,20},{5,15},{7,15},{3,10},{4,15},{6,15}}};
  Tomb T,C;
  clrscr();
  if (KellKiiras)
    GrafKiir(&G);

  /* A 1. pontbl kiindul utakat */
  Dijkstra(&G,T,C,0);     /* 0-tl indexelnk */

  /* A 1. pontbl a 4. pontba */
  UtKiir(&G,T,C,0,3);
}
