{ tkeress Dijkstra mdszerrel }
program DIJKSTRAP;
uses crt;
const
  MaxPontDb=8;                      { A pontok maximlis szma }
  MaxElDb=MaxPontDb*(MaxPontDb-1);  { Az lek maximlis szma }
  MaxElHossz=99;                    { A maximlis lhossz }
  NincsEl=-1;                       { A nemltez l jelzsre }
  MaxUtHossz=MaxElDb*MaxElHossz;    { A maximlis thossz }
  Vegtelen=MaxUtHossz+1;            { A 'vgtelen' kezelshez }
  KellKiiras=true;                  { Legyenek-e ellenrz kirsok }
  NincsCimke=-1;                    { A nemltez cmke jelzsre }
type
  Pont=record                       { A pontrekord }
    Azon:char;                      { Pontazonost }
    x,y:integer;                    { Koordintk }
  end;
  { Az leket egydimenzis tmbben troljuk }
  El=record                        { Az lrekord }
    Vp:integer;                    { Vgpontindex }
    ElHossz:integer;               { lhossz }
  end;
  Graf=record                                { A grf }
    PontDb:integer;                          { Pontok szma }
    Pontok:array[1..MaxPontDb] of Pont;      { Pontok }
    ElMut:array[1..MaxPontDb+1] of integer;  { lmutatk }
    ElDb:integer;                            { lek szma }
    Elek:array[1..MaxElDb] of El;            { lek }
  end;
  { Az egydimenzis tmbkhz (A,T,C) }
  Tomb=array[1..MaxPontDb] of integer;

procedure GrafKiir(const G:Graf);
var i,j,k:integer;
begin
  writeln('Pontok szma:',G.PontDb);
  writeln('Index Az-     X     Y');
  for i:=1 to G.PontDb do
    writeln(i:5,' ',G.Pontok[i].Azon:4,G.Pontok[i].x:6,G.Pontok[i].y:6);
  readkey;
  writeln('A grf lei:');
  k:=1;
  for i:=1 to G.PontDb do
    for j:=G.ElMut[i] to G.ElMut[i+1]-1 do begin
      writeln(G.Pontok[i].Azon,' - ',G.Pontok[G.Elek[j].Vp].Azon,
        ' : ',G.Elek[j].ElHossz);
      inc(k);
      if k mod 20=0 then readkey;
    end;
  readkey;
end;

procedure AdatKiir(const G:Graf; const A,T,C:Tomb; ADb:integer);
var i:integer;
begin
  write('A:');
  for i:=1 to ADb do
    write(G.Pontok[A[i]].Azon:6);
  writeln; write('T:');
  for i:=1 to G.PontDb do
    if T[i]=Vegtelen then
      write('-':6)
    else
      write(T[i]:6);
  writeln; write('C:');
  for i:=1 to G.PontDb do
    if C[i]=NincsCimke then
      write(' ':6)
    else
      write(C[i]:6);
  writeln;
  readkey;
end;

procedure Dijkstra(const G:Graf; var T,C:Tomb; Kp:integer);
var A:Tomb; ADb:integer;
    Akt:array[1..MaxPontDb] of boolean;  { A pontok aktvsga }
    x,y,i,j,k:integer;
begin
  { Kezdllapot }
  for i:=1 to G.PontDb do begin
    T[i]:=Vegtelen;
    Akt[i]:=false;
    C[i]:=NincsCimke;   { Csak a kirshoz kell }
  end;
  T[Kp]:=0;
  C[Kp]:=Kp;
  ADb:=1;
  A[ADb]:=Kp;
  Akt[Kp]:=true;
  if KellKiiras then begin
    writeln('A kezdllapot');
    AdatKiir(G,A,T,C,ADb);
  end;
  { Javt lpsek }
  if KellKiiras then j:=0;       { A javt lpsek szma }
  while ADb>0 do begin
    { Az A minimlis tvolsg elemt X-be }
    k:=1;
    for i:=2 to ADb do
      if T[A[i]]<T[A[k]] then k:=i;
    x:=A[k];
    { X trlse A-bl (az utols elemmel fellrjuk) }
    A[k]:=A[ADb];
    ADb:=ADb-1;
    Akt[x]:=false;
    { Rvidts X-n keresztl }
    for i:=G.ElMut[x] to G.ElMut[x+1]-1 do begin
      y:=G.Elek[i].Vp;
      if T[x]+G.Elek[i].ElHossz<T[y] then begin
	T[y]:=T[x]+G.Elek[i].ElHossz;
	C[y]:=x;
	if not Akt[y] then begin
	  { Y mg nem aktv, hozzvesszk A-hoz }
	  ADb:=ADb+1;
	  A[ADb]:=y;
	  Akt[y]:=true;
	end;
      end;
    end;
    if KellKiiras then begin
      inc(j);
      writeln(j,'. javt lps (x=',G.Pontok[x].Azon,') utn');
      AdatKiir(G,A,T,C,ADb);
    end;
  end;
end;

procedure UtKiir(const G:Graf; const T,C:Tomb; Kp,Vp:integer);
var Ut:Tomb;       { A Kp-Vp t pontindexei }
    UtDb:integer;  { Az t pontjainak szma }
    x,cs:integer;
begin
  writeln(G.Pontok[Kp].Azon,' - ',G.Pontok[Vp].Azon,' viszonylat');
  if T[Vp]=Vegtelen then
    writeln('Nem lehet eljutni!')
  else begin
    { Az t sszeraksa (visszafel haladva) }
    UtDb:=1;
    Ut[UtDb]:=Vp;
    x:=Vp;
    repeat
      x:=C[x];
      UtDb:=UtDb+1;
      Ut[UtDb]:=x;
    until x=Kp;
    { Az t megfordtsa }
    for x:=1 to UtDb div 2 do begin
      cs:=Ut[x]; Ut[x]:=Ut[UtDb-x+1]; Ut[UtDb-x+1]:=cs;
    end;
    { Az t kirsa }
    writeln('A tvolsg:',T[Vp]);
    write('Az t:');
    for x:=1 to UtDb do
      write(G.Pontok[Ut[x]].Azon,' ');
    writeln;
    readkey;
  end;
end;

const
  { A pldagrf az leket egydimenzis tmbben trolva }
  G:Graf=
   (PontDb:8;
    Pontok:((Azon:'1';x:0;y:20),(Azon:'2';x:20;y:40),(Azon:'3';x:40;y:20),
            (Azon:'4';x:20;y:0),(Azon:'5';x:10;y:20),(Azon:'6';x:20;y:30),
            (Azon:'7';x:30;y:20),(Azon:'8';x:20;y:10));
    ElMut:(1,4,7,10,13,17,20,24,27);
    ElDb:26;
    Elek:(
      (Vp:2;ElHossz:40),(Vp:4;ElHossz:40),(Vp:5;ElHossz:10),(Vp:1;ElHossz:40),
      (Vp:3;ElHossz:40),(Vp:6;ElHossz:10),(Vp:2;ElHossz:40),(Vp:4;ElHossz:40),
      (Vp:7;ElHossz:10),(Vp:1;ElHossz:40),(Vp:3;ElHossz:40),(Vp:8;ElHossz:10),
      (Vp:1;ElHossz:10),(Vp:6;ElHossz:15),(Vp:7;ElHossz:20),(Vp:8;ElHossz:15),
      (Vp:2;ElHossz:10),(Vp:5;ElHossz:15),(Vp:7;ElHossz:15),(Vp:3;ElHossz:10),
      (Vp:5;ElHossz:20),(Vp:6;ElHossz:15),(Vp:8;ElHossz:15),(Vp:4;ElHossz:10),
      (Vp:5;ElHossz:15),(Vp:7;ElHossz:15),
      (Vp:0;ElHossz:0),(Vp:0;ElHossz:0),(Vp:0;ElHossz:0),(Vp:0;ElHossz:0),
      (Vp:0;ElHossz:0),(Vp:0;ElHossz:0),(Vp:0;ElHossz:0),(Vp:0;ElHossz:0),
      (Vp:0;ElHossz:0),(Vp:0;ElHossz:0),(Vp:0;ElHossz:0),(Vp:0;ElHossz:0),
      (Vp:0;ElHossz:0),(Vp:0;ElHossz:0),(Vp:0;ElHossz:0),(Vp:0;ElHossz:0),
      (Vp:0;ElHossz:0),(Vp:0;ElHossz:0),(Vp:0;ElHossz:0),(Vp:0;ElHossz:0),
      (Vp:0;ElHossz:0),(Vp:0;ElHossz:0),(Vp:0;ElHossz:0),(Vp:0;ElHossz:0),
      (Vp:0;ElHossz:0),(Vp:0;ElHossz:0),(Vp:0;ElHossz:0),(Vp:0;ElHossz:0),
      (Vp:0;ElHossz:0),(Vp:0;ElHossz:0)));
var T,C:Tomb;
begin
  clrscr;
  if KellKiiras then
    GrafKiir(G);

  { A 1. pontbl kiindul utakat }
  Dijkstra(G,T,C,1);

  { A 1. pontbl a 4. pontba }
  UtKiir(G,T,C,1,4);
end.
