/* ELLINP.C : Ellenrztt input */

#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define Max 256               /* Karakterhalmazok maximlis elemszma */
#define Sotet 0               /* A sznkiemelshez */
#define Vilagos 7
#define Kilep 27              /* Esc */        /* Vezrlbillentyk */
#define AdatVeg 13            /* Enter */
#define Torol 8               /* Backspace */

#define MaxRszHossz 6         /* A rendszm maximlis hossza */
#define MaxEgSzHossz 11       /* Az egsz szm maximlis hossza */
#define Elojel '-'            /* Eljel */

typedef int Jelek[Max];

void Ures(int *Jelek)
{ int i;
  for (i=0; i<Max; i++) Jelek[i]=0;
}

void Bovit(int *Mit, int Tol, int Ig)
{ int i;
  for (i=Tol; i<=Ig; i++) Mit[i]=1;
}

void Csokkent(int *Mit, int Tol, int Ig)
{ int i;
  for (i=Tol; i<=Ig; i++) Mit[i]=0;
}

void Bovit1(int *Mit, int Mivel)
{ Mit[Mivel]=1;
}

void Csokkent1(int *Mit, int Mivel)
{ Mit[Mivel]=0;
}

int Eleme(int Mi, int *Minek)
{ return (Minek[Mi]==1);
}

void Unio(int *Eredmeny, int *Mit, int *Mivel)
{ int i;
  for (i=0; i<=Max; i++)
    Eredmeny[i]=Eleme(i,Mit) || Eleme(i,Mivel);
}

void Metszet(int *Eredmeny, int *Mit, int *Mivel)
{ int i;
  for (i=0; i<=Max; i++)
    Eredmeny[i]=Eleme(i,Mit) && Eleme(i,Mivel);
}

int BillBe(int *Normal, int *Dupla, int *Duplae)
{ int Jel,JoJel;
  do {
    Jel=getch(); *Duplae=Jel==0;
    if (*Duplae) {
      Jel=getch();
      JoJel=Dupla[Jel];
    } else
      JoJel=Normal[Jel];
  } while (!JoJel);
  return (Jel);
}

int JelBe(int *JoJelek)
{ int Duplae; Jelek d;
  Ures(d);
  return (BillBe(JoJelek,d,&Duplae));
}

char *JobbTolt(char *Mit, int Hossz)
{ while (strlen(Mit)<Hossz)
    strcat(Mit," ");
  return (Mit);
}

void NormalIr(void)
{ textcolor(Vilagos); textbackground(Sotet);
}

void InverzIr(void)
{ textcolor(Sotet); textbackground(Vilagos);
}

void Ir(char *Mit, int Oszl, int Sor)
{ if (Oszl==0) Oszl=wherex();
  if (Sor==0) Sor=wherey();
  gotoxy(Oszl,Sor); cprintf(Mit);
}

void KiIras(char *Mit, int Oszl, int Sor, int Hossz)
{ Ir(Mit,Oszl,Sor); gotoxy(Oszl+Hossz,Sor);
}

void RendSzamBe(char *RendSzam,           /* i/o eredmny szveg  */
		int Oszl, int Sor,        /* i   kpernypozci  */
		int *VanAdat              /* o   van-e j adat    */)
{ Jelek JoJel,AdatJel,SzamJegyek,Betuk;
  char Jel;
  int Hossz;
  char UresRsz[MaxRszHossz+1];

  /* Halmazok kezdrtkei */
  Ures(SzamJegyek); Bovit(SzamJegyek,'0','9');
  Ures(Betuk); Bovit(Betuk,'A','Z'); Bovit(Betuk,'a','z');
  Unio(AdatJel,Betuk,SzamJegyek);
  /* Elkszts */
  /* Adat */
  Hossz=strlen(RendSzam); JobbTolt(RendSzam,MaxRszHossz);
  /* Kperny */
  if (Oszl==0) Oszl=wherex();
  if (Sor==0) Sor=wherey();
  InverzIr();
  KiIras(RendSzam,Oszl,Sor,Hossz);
  /* Beolvass */
  do {
    /* JoJel bellts */
    Ures(JoJel);
    Bovit1(JoJel,Kilep);
    if (Hossz<=1)
      Unio(JoJel,JoJel,Betuk);
    else if (Hossz==2)
      Unio(JoJel,JoJel,AdatJel);
    else if (Hossz<=5)
      Unio(JoJel,JoJel,SzamJegyek);
    if (Hossz>0) Bovit1(JoJel,Torol);
    /* Utols szmjegy */
    if (Hossz==5 && (Eleme(RendSzam[2],Betuk) || RendSzam[2]=='0') &&
	  RendSzam[3]=='0' && RendSzam[4]=='0')
	Csokkent1(JoJel,'0');
    if (Hossz==MaxRszHossz) Bovit1(JoJel,AdatVeg);
    /* Jel beolvass */
    Jel=JelBe(JoJel);
    /* Jel feldolgozs */
    if (Eleme(Jel,AdatJel)) {
      /* Ha kisbet, nagybetss alaktjuk */
      if (Jel>='a' && Jel<='z') Jel=Jel-32;
      RendSzam[Hossz]=Jel; Hossz++;
    } else if (Jel==Torol) {
      Hossz--; RendSzam[Hossz]=' ';
    }
    KiIras(RendSzam,Oszl,Sor,Hossz);
  } while (Jel!=Kilep && Jel!=AdatVeg);
  /* Befejezs */
  *VanAdat=Jel!=Kilep;
  /* Inverz kiemels levtele */
  NormalIr();
  UresRsz[0]='\0'; JobbTolt(UresRsz,MaxRszHossz);
  KiIras(UresRsz,Oszl,Sor,MaxRszHossz);
  /* Hosszbellts */
  if (*VanAdat) RendSzam[Hossz]='\0';
  else RendSzam[0]='\0';
  KiIras(RendSzam,Oszl,Sor,Hossz);
}

void EgSzamBe(char *SzamSzov,           /* i/o eredmny szveg  */
	      int Oszl, int Sor,        /* i   kpernypozci  */
	      long Tol, long Ig,        /* i   hatrok          */
	      int *VanAdat,             /* o   van-e j adat    */
	      long *SzamErt             /* o   az eredmny szm */)
{ Jelek JoJel,SzamJegyek;
  char Jel;
  int Hossz,JoAdat,MaxH;
  char UresEgSz[MaxEgSzHossz+1];
  char w[MaxEgSzHossz+1];
  double x;

  /* Halmazok kezdrtkei */
  Ures(SzamJegyek); Bovit(SzamJegyek,'0','9');
  /* Elkszts */
  /* Adat */
  ltoa(Tol,w,10); MaxH=strlen(w); ltoa(Ig,w,10);
  if (MaxH<strlen(w)) MaxH=strlen(w);
  Hossz=strlen(SzamSzov); JobbTolt(SzamSzov,MaxH);
  /* Kperny */
  if (Oszl==0) Oszl=wherex();
  if (Sor==0) Sor=wherey();
  InverzIr();
  KiIras(SzamSzov,Oszl,Sor,Hossz);
  /* Beolvass */
  do {
    /* Tartalmi helyessg: Tol-Ig */
    do {
      /* Formai helyessg: csak szm */
      /* JoJel bellts */
      Ures(JoJel);
      Bovit1(JoJel,Kilep);
      if (Hossz<MaxH) Unio(JoJel,JoJel,SzamJegyek);
      if (Hossz==0 && Tol<0) Bovit1(JoJel,Elojel);
      if (Hossz>0) Bovit1(JoJel,Torol);
      if (Hossz>0 && Eleme(SzamSzov[Hossz-1],SzamJegyek))
	Bovit1(JoJel,AdatVeg);
      /* Jel beolvass */
      Jel=JelBe(JoJel);
      /* Jel feldolgozs */
      if (Eleme(Jel,SzamJegyek) || Jel==Elojel) {
	SzamSzov[Hossz]=Jel; Hossz++;
      } else if (Jel==Torol) {
	Hossz--; SzamSzov[Hossz]=' ';
      }
      KiIras(SzamSzov,Oszl,Sor,Hossz);
    } while (Jel!=Kilep && Jel!=AdatVeg);
    /* Tartomny ellenrzs */
    if (Jel!=Kilep) {
      w[0]='\0'; strncat(w,SzamSzov,Hossz); x=atof(w);
      JoAdat=(x>=Tol && x<=Ig);
    };
  } while (Jel!=Kilep && !JoAdat);
  /* Befejezs */
  *VanAdat=Jel!=Kilep;
  /* Inverz kiemels levtele */
  NormalIr();
  UresEgSz[0]='\0'; JobbTolt(UresEgSz,MaxH);
  KiIras(UresEgSz,Oszl,Sor,MaxH);
  /* Hosszbellts */
  if (*VanAdat) {
    SzamSzov[Hossz]='\0';
    *SzamErt=x;
  } else SzamSzov[0]='\0';
  KiIras(SzamSzov,Oszl,Sor,Hossz);
}

void main()
{ char st[20]; int van; long l;

  NormalIr(); clrscr();

  st[0]='\0';
  printf("Rendszm:");
  RendSzamBe(st,0,0,&van);
  printf("\n");
  if (van)
    printf("A megadott rendszm:%s\n",st);
  else
    printf("Nem adott meg adatot!\n");
  printf("\n");

  st[0]='\0';
  printf("Egsz szm [-128,127]:");
  EgSzamBe(st,0,0,-128,127,&van,&l);
  printf("\n");
  if (van)  {
    printf("A megadott szm sztringknt:%s\n",st);
    printf("A megadott szm szmknt:%ld\n",l);
  } else
    printf("Nem adott meg adatot!");
}
