{ tkeress Floyd-Warshall mdszerrel }
program FLO_WAR;
uses crt;
const
  MaxPontDb=5;                      { A pontok maximlis szma }
  MaxElDb=MaxPontDb*(MaxPontDb-1);  { Az lek maximlis szma }
  MaxElHossz=99;                    { A maximlis lhossz }
  NincsEl=-1;                       { A nemltez l jelzsre }
  MaxUtHossz=MaxElDb*MaxElHossz;    { A maximlis thossz }
  Vegtelen=MaxUtHossz+1;            { A 'vgtelen' kezelshez }
  KellKiiras=true;                  { Legyenek-e ellenrz kirsok }
type
  Pont=record                       { A pontrekord }
    Azon:char;                      { Pontazonost }
    x,y:integer;                    { Koordintk }
  end;
  { A mtrixos trolshoz }
  Matrix=array[1..MaxPontDb,1..MaxPontDb] of integer;

  Graf=record                                { A grf }
    PontDb:integer;                          { Pontok szma }
    Pontok:array[1..MaxPontDb] of Pont;      { Pontok }
    ElHossz:Matrix;                          { lhossz mtrix }
  end;

procedure MtxKiir(Szoveg:string; const a:Matrix; n:integer);
var i,j:integer;
begin
  writeln(Szoveg);
  for i:=1 to n do begin
    for j:=1 to n do
      if a[i,j]=Vegtelen then
        write('-':6)
      else
        write(a[i,j]:6);
    writeln;
  end;
end;

procedure Floyd_Warshall(const G:Graf; var T,C:Matrix);
var x,y,w:integer;
begin
  { Kezdllapot }
  for x:=1 to G.PontDb do
    for y:=1 to G.PontDb do begin
      if x=y then
	T[x,y]:=0
      else
	if G.ElHossz[x,y]=NincsEl then
	  T[x,y]:=Vegtelen
	else
	  T[x,y]:=G.ElHossz[x,y];
      C[x,y]:=y;
    end;
  if KellKiiras then begin
    writeln('A kezdllapot');
    MtxKiir('T:',T,G.PontDb);
    MtxKiir('C:',C,G.PontDb);
    readkey;
  end;
  { Javt lpsek }
  for w:=1 to G.PontDb do begin
    for x:=1 to G.PontDb do
      for y:=1 to G.PontDb do
	if T[x,w]+T[w,y]<T[x,y] then begin
	  T[x,y]:=T[x,w]+T[w,y];
	  C[x,y]:=C[x,w];
	end;
    if KellKiiras then begin
      writeln(w,'. javt lps utn:');
      MtxKiir('T:',T,G.PontDb);
      MtxKiir('C:',C,G.PontDb);
      readkey;
    end;
  end;
end;

procedure GrafKiir(const G:Graf);
var i,j,k:integer;
begin
  writeln('Pontok szma:',G.PontDb);
  writeln('Index Az-     X     Y');
  for i:=1 to G.PontDb do
    writeln(i+1:5,' ',G.Pontok[i].Azon:4,G.Pontok[i].x:6,G.Pontok[i].y:6);
  readkey;
  writeln('A grf lei:');
  k:=1;
  for i:=1 to G.PontDb do
    for j:=1 to G.PontDb do
      if (i<>j) and (G.ElHossz[i,j]<>NincsEl) then begin
	writeln(G.Pontok[i].Azon,' - ',G.Pontok[j].Azon,' : ',G.ElHossz[i,j]);
        inc(k);
	if k mod 20=0 then readkey;
      end;
  readkey;
end;

procedure UtKiir(const G:Graf; const T,C:Matrix; Kp,Vp:integer);
var x:integer;
begin
  writeln(G.Pontok[Kp].Azon,' - ',G.Pontok[Vp].Azon,' viszonylat');
  if T[Kp,Vp]=Vegtelen then
    writeln('Nem lehet eljutni!')
  else begin
    writeln('A tvolsg:',T[Kp,Vp]);
    write('Az t:');
    x:=Kp;
    write(G.Pontok[x].Azon,' ');
    repeat
      x:=C[x,Vp];
      write(G.Pontok[x].Azon,' ');
    until x=Vp;
    writeln;
    readkey;
  end;
end;

const
  { A pldagrf mtrixos trolsban }
  G:Graf=(PontDb:5;
          Pontok:((Azon:'1';x:0;y:20),(Azon:'2';x:15;y:20),
                  (Azon:'3';x:8;y:12),(Azon:'4';x:0;y:0),
                  (Azon:'5';x:15;y:0));
          ElHossz:((0,15,10,NincsEl,NincsEl),(NincsEl,0,NincsEl,NincsEl,20),
          	   (10,10,0,13,NincsEl),(20,NincsEl,NincsEl,0,15),
	           (NincsEl,20,13,NincsEl,0)));
var T,C:Matrix;
begin
  clrscr;
  if KellKiiras then
    GrafKiir(G);

  Floyd_Warshall(G,T,C);

  { A 2. pontbl a 4. pontba }
  UtKiir(G,T,C,2,4);
end.
