/* GYRENDNR.C : Gyorsrendezs nem rekurzvan, sajt veremkezelssel */

#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define MaxElemSzam 10            /* A rendezend adatok maximlis szma */
#define MaxElem 20                /* A generland adatok maximlis rtke */

typedef int Elem;                 /* A rendezend elemek tpusa */
typedef Elem Tomb[MaxElemSzam];   /* A rendezend elemek tmbje */

#define MaxVeremMeret 4    /* A verem maximlis mrete (log2(MaxElemSzam) */
typedef struct {           /* A veremben trolt elemek tpusa */
  int k,v;                 /* A rendezend elemek indexhatrai */
} VeremElem;
typedef VeremElem TVerem[MaxVeremMeret];    /* A verem tpusa */

/* Adat bettele a verembe */
void Verembe(TVerem Verem, int *VeremMut, int k, int v)
{ (*VeremMut)++;
  Verem[*VeremMut].k=k;
  Verem[*VeremMut].v=v;
}

/* Adat kivtele a verembl */
void Verembol(TVerem Verem, int *VeremMut, int *k, int *v)
{ *k=Verem[*VeremMut].k;
  *v=Verem[*VeremMut].v;
  (*VeremMut)--;
}

/* A rendez eljrs */
void GyorsRend(Tomb a, int n)
{ TVerem Verem;
  Elem s,cs;
  int VeremMut,k,v,i,j;

  /* A verem inicializlsa */
  VeremMut=-1;  /* Mert 0-tl indexelnk */
  /* A teljes rendezend rszt a verembe */
  Verembe(Verem,&VeremMut,0,n-1);
  while (VeremMut>-1) {
    /* A rendezend rsz kivtele a verembl */
    Verembol(Verem,&VeremMut,&k,&v);
    if (k<v) {
      /* Van legalbb kt elem */
      i=k; j=v; s=a[(i+j)/2];
      /* Sztvlogats a strzsa (s) elemhez kpest */
      while (i<=j) {
	while (a[i]<s) i++;
	while (a[j]>s) j--;
	if (i<=j) {
	  /* Az i. s j. elemek cserje */
	  cs=a[i]; a[i]=a[j]; a[j]=cs;
	  i++; j--;
	}
      }
      /* A kt rsz felvtele a verembe (fellre a kisebb rszt) */
      if (j-k>v-i) {
	Verembe(Verem,&VeremMut,k,j);
	Verembe(Verem,&VeremMut,i,v);
      } else {
	Verembe(Verem,&VeremMut,i,v);
	Verembe(Verem,&VeremMut,k,j);
      }
    }
  }
}

/* Elemek generlsa */
void General(Tomb a, int n)
{ int i;
  for (i=0; i<n; i++) a[i]=random(MaxElem+1);
}

void Kiiras(char *Szoveg, Tomb a, int n)
{ int i;
  printf("%s\n",Szoveg);
  for (i=0; i<n; i++) printf("%d ",a[i]);
  printf("\n");
}

void main(void)
{ Tomb a;
  randomize(); clrscr();

  General(a,MaxElemSzam);
  Kiiras("Rendezs eltt",a,MaxElemSzam);

  /* Sorbarendezs */
  GyorsRend(a,MaxElemSzam);

  Kiiras("Rendezs utn",a,MaxElemSzam);
}
