{ Gyorsrendezs nem rekurzvan, sajt veremkezelssel }
program GYRENDNR;
uses crt;
const
  MaxElemSzam=10;             { A rendezend adatok maximlis szma }
  MaxElem=20;                 { A generland adatok maximlis rtke }
type
  Elem=integer;                         { A rendezend elemek tpusa }
  Tomb=array[1..MaxElemSzam] of Elem;   { A rendezend elemek tmbje }
const
  MaxVeremMeret=4;     { A verem maximlis mrete (log2(MaxElemSzam) }
type
  VeremElem=record                 { A veremben trolt elemek tpusa }
    k,v:integer;                   { A rendezend elemek indexhatrai }
  end;
  TVerem=array[1..MaxVeremMeret] of VeremElem;      { A verem tpusa }

{ Adat bettele a verembe }
procedure Verembe(var Verem:TVerem; var VeremMut:integer; k,v:integer);
begin
  inc(VeremMut);
  Verem[VeremMut].k:=k;
  Verem[VeremMut].v:=v;
end;

{ Adat kivtele a verembl }
procedure Verembol(var Verem:TVerem; var VeremMut,k,v:integer);
begin
  k:=Verem[VeremMut].k;
  v:=Verem[VeremMut].v;
  dec(VeremMut);
end;

{ A rendez eljrs }
procedure GyorsRend(var a:Tomb; n:integer);
var Verem:TVerem;
    s,cs:Elem;
    VeremMut,k,v,i,j:integer;
begin
  { A verem inicializlsa }
  VeremMut:=0;
  { A teljes rendezend rszt a verembe }
  Verembe(Verem,VeremMut,1,n);
  while VeremMut>0 do begin
    { A rendezend rsz kivtele a verembl }
    Verembol(Verem,VeremMut,k,v);
    if k<v then begin
      { Van legalbb kt elem }
      i:=k; j:=v; s:=a[(i+j) div 2];
      { Sztvlogats a strzsa (s) elemhez kpest }
      while i<=j do begin
	while a[i]<s do inc(i);
	while a[j]>s do dec(j);
	if i<=j then begin
	  { Az i. s j. elemek cserje }
	  cs:=a[i]; a[i]:=a[j]; a[j]:=cs;
	  inc(i); dec(j);
	end;
      end;
      { A kt rsz felvtele a verembe (fellre a kisebb rszt) }
      if j-k>v-i then begin
	Verembe(Verem,VeremMut,k,j);
	Verembe(Verem,VeremMut,i,v);
      end else begin
	Verembe(Verem,VeremMut,i,v);
	Verembe(Verem,VeremMut,k,j);
      end;
    end;
  end;
end;

{ Elemek generlsa }
procedure General(var a:Tomb; n:integer);
var i:integer;
begin
  for i:=1 to n do
    a[i]:=random(MaxElem+1);
end;

procedure Kiiras(Szoveg:string; const a:Tomb; n:integer);
var i:integer;
begin
  writeln(Szoveg);
  for i:=1 to n do write(a[i],' ');
  writeln;
end;

var a:Tomb;
begin
  randomize; clrscr;

  General(a,MaxElemSzam);
  Kiiras('Rendezs eltt',a,MaxElemSzam);

  { Sorbarendezs }
  GyorsRend(a,MaxElemSzam);

  Kiiras('Rendezs utn',a,MaxElemSzam);
end.

