/* KOLL.C : Kollekci hasznlata lottszelvnyek kirtkelsre */

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <time.h>

char *FNevI="KOLL_I.TXT";      /* A szelvnyeket tartalmaz szvegfjl */
char *FNevO="KOLL_O.TXT";      /* A kirtkelt szelvnyek szvegfjlja */

#define MaxSzelv 2000          /* A betlthet szelvnyek maximlis szma */
#define MaxGen 2200            /* A generland szelvnyek szma */
#define Db 6                   /* A lottszmok darabszma egy szelvnyen */
#define Max 45                 /* Egy lottszm maximlis rtke */
#define MinTal 3               /* A minimlis tallatszm a nyershez */

typedef int Szelveny[Db];                /* Lottszelvny */
typedef struct {                         /* A kollekci ttele */
  Szelveny Sz;                           /* A szmok */
  int Tal;                               /* Tallatok szma a szelvnyen */
} Tetel;

typedef Tetel *Kollekcio[MaxSzelv];      /* A kollekci */
typedef int Stat[Db+1];                  /* Statisztika */
typedef int Halmaz[Max];                 /* A halmaz */

/* Egy db lottszelvny generlsa */
void General(Szelveny Sz)
{ Halmaz h; int i,j,x;
  for (i=0; i<Max; i++) h[i]=0;
  for (i=0; i<Db; i++) {
    do {
      x=random(Max);
    } while (h[x]);
    h[x]=1;
  }
  i=0;
  for (j=0; j<Max; j++)
    if (h[j]) {
      Sz[i]=j+1; i++;
    }
}

/* N db lottszelvny generlsa az FNev nev szvegfjlba */
void FajlbaGeneral(char *FNev, int N)
{ FILE *f; Szelveny Sz;
  int i,j;
  f=fopen(FNev,"w");
  for (i=0; i<N; i++) {
    General(Sz);
    for (j=0; j<Db; j++) fprintf(f,"%3d",Sz[j]);
    fprintf(f,"\n");
  }
  fclose(f);
}

/* Az FNev nev szvegfjl szelvnyeinek betltse */
int Betolt(char *FNev, Kollekcio K, int *KDb)
{ FILE *f; int i,j,Kilep,Ok; Szelveny Sz;
  /* Adatbeolvass */
  f=fopen(FNev,"r");
  *KDb=0; Kilep=0;
  while (!Kilep) {
    if (*KDb>=MaxSzelv) Kilep=1;
    else {
      for (i=0; i<Db; i++)
	if (fscanf(f,"%d",&Sz[i])!=1) Kilep=1;
      if (!Kilep) {
	/* Van adat */
	if ((K[*KDb]=(Tetel*)malloc(sizeof(Tetel)))!=NULL) {
	  /* Van hely */
	  for (j=0; j<Db; j++)
	    (*(K[*KDb])).Sz[j]=Sz[j];
	  (*KDb)++;
	} else Kilep=1;
      }
    }
  }
  /* Nincs mr tbb adat a fjlban? */
  Ok=(fscanf(f,"%d",&i)!=1);
  fclose(f);
  return (Ok);
}

/* Kirtkels, a nyerszelvnyek kirsa az FNev nev szvegfjlba */
void Ertekel(char *FNev, Kollekcio K, int KDb, Szelveny Ny)
{ FILE *f; Halmaz h;
  Stat S; int i,j,l;
  /* Nyerszmok halmaza */
  for (i=0; i<Max; i++) h[i]=0;
  for (i=0; i<Db; i++) h[Ny[i]]=1;
  /* Statisztika kezdrtke */
  for (i=0; i<=Db; i++) S[i]=0;
  /* A szelvnyek kirtkelse */
  for (i=0; i<KDb; i++) {
    (*K[i]).Tal=0;
    for (j=0; j<Db; j++)
      if (h[(*K[i]).Sz[j]]==1) (*K[i]).Tal++;
    /* Statisztika */
    S[(*K[i]).Tal]++;
  }
  /* Adatkirs */
  f=fopen(FNev,"w");
  fprintf(f,"A nyerszmok\n");
  for (i=0; i<Db; i++) fprintf(f,"%3d",Ny[i]); fprintf(f,"\n");
  /* A nyerszelvnyek */
  for (l=Db; l>=MinTal; l--) {
    fprintf(f,"%d tallatos szelvnyek szma:%d\n",l,S[l]);
    for (i=0; i<KDb; i++)
      if ((*K[i]).Tal==l) {
	for (j=0; j<Db; j++)
	  fprintf(f,"%3d",(*K[i]).Sz[j]);
	fprintf(f,"\n");
      }
  }
  fclose(f);
}

void main()
{ Kollekcio K; int KDb; Szelveny Ny;
  clrscr(); randomize();
  /* Adatgenerls */
  FajlbaGeneral(FNevI,MaxGen);
  printf("%d db szelvny generlva (%s)\n",MaxGen,FNevI);
  /* Adatbeolvass */
  if (!Betolt(FNevI,K,&KDb))
    printf("Nem frt be minden szelvny!\n");
  printf("A betlttt szelvnyek szma:%d\n",KDb);
  /* Nyerszmok generlsa */
  General(Ny);
  /* Kirtkels */
  Ertekel(FNevO,K,KDb,Ny);
  printf("A kirtkels elkszlt (%s)\n",FNevO);
}
