{ Kollekci hasznlata lottszelvnyek kirtkelsre }
program KOLL;
uses crt;
const
  FNevI='KOLL_I.TXT';             { A szelvnyeket tartalmaz szvegfjl }
  FNevO='KOLL_O.TXT';             { A kirtkelt szelvnyek szvegfjlja }
  MaxSzelv=16000;                 { A betlthet szelvnyek maximlis szma }
  MaxGen=20000;                   { A generland szelvnyek szma }
  Db=6;                           { A lottszmok darabszma egy szelvnyen }
  Max=45;                         { Egy lottszm maximlis rtke }
  MinTal=3;                       { A minimlis tallatszm a nyershez }
type
  Szelveny=array[1..Db] of byte;         { Lottszelvny }
  Tetel=record                           { A kollekci ttele }
    Sz:Szelveny;                         { A szmok }
    Tal:byte;                            { Tallatok szma a szelvnyen }
  end;
  TetelMut=^Tetel;
  Kollekcio=array[1..MaxSzelv] of TetelMut;       { A kollekci }
  Stat=array[0..Db] of word;                      { Statisztika }

{ Egy db lottszelvny generlsa }
procedure General(var Sz:Szelveny);
var h:set of byte; i,j,x:byte;
begin
  h:=[];
  for i:=1 to Db do begin
    repeat
      x:=random(Max)+1;
    until not (x in h);
    h:=h+[x];
  end;
  i:=0;
  for j:=1 to Max do
    if j in h then begin
      inc(i); Sz[i]:=j;
    end;
end;

{ N db lottszelvny generlsa az FNev nev szvegfjlba }
procedure FajlbaGeneral(FNev:string; N:word);
var
  f:text; Sz:Szelveny;
  i,j:word;
begin
  assign(f,FNev);
  rewrite(f);
  for i:=1 to N do begin
    General(Sz);
    for j:=1 to Db do write(f,Sz[j]:3);
    writeln(f);
  end;
  close(f);
end;

{ Az FNev nev szvegfjl szelvnyeinek betltse }
function Betolt(FNev:string; var K:Kollekcio; var KDb:word):boolean;
var f:text; i:byte; Ok:boolean;
begin
  { Adatbeolvass }
  assign(f,FNev);
  reset(f);
  KDb:=0;
  while not eof(f) and (maxavail>=sizeof(Tetel)) and (KDb<MaxSzelv) do begin
    inc(KDb);
    new(K[KDb]);
    for i:=1 to Db do read(f,K[KDb]^.Sz[i]);
    readln(f);
  end;
  Ok:=eof(f);
  close(f);
  Betolt:=Ok;
end;

{ Kirtkels, a nyerszelvnyek kirsa az FNev nev szvegfjlba }
procedure Ertekel(FNev:string; var K:Kollekcio; KDb:word; const Ny:Szelveny);
var f:text; h:set of byte;
    S:Stat; i,j,l:word;
begin
  { Nyerszmok halmaza }
  h:=[];
  for i:=1 to Db do h:=h+[Ny[i]];
  { Statisztika kezdrtke }
  for i:=0 to Db do S[i]:=0;
  { A szelvnyek kirtkelse }
  for i:=1 to KDb do begin
    K[i]^.Tal:=0;
    for j:=1 to Db do
      if K[i]^.Sz[j] in h then inc(K[i]^.Tal);
    { Statisztika }
    inc(S[K[i]^.Tal]);
  end;
  { Adatkirs }
  assign(f,FNev);
  rewrite(f);
  writeln(f,'A nyerszmok');
  for i:=1 to Db do write(f,Ny[i]:3); writeln(f);
  { A nyerszelvnyek }
  for l:=Db downto MinTal do begin
    writeln(f,l,' tallatos szelvnyek szma:',S[l]);
    for i:=1 to KDb do
      if K[i]^.Tal=l then begin
        for j:=1 to Db do
          write(f,K[i]^.Sz[j]:3);
        writeln(f);
      end;
  end;
  close(f);
end;

var
  K:Kollekcio; KDb:Word; Ny:Szelveny;
begin
  clrscr; randomize;
  { Adatgenerls }
  FajlbaGeneral(FNevI,MaxGen);
  writeln(MaxGen,' db szelvny generlva (',FNevI,')');
  { Adatbeolvass }
  if not Betolt(FNevI,K,KDb) then
    writeln('Nem frt be minden szelvny!');
  writeln('A betlttt szelvnyek szma:',KDb);
  { Nyerszmok generlsa }
  General(Ny);
  { Kirtkels }
  Ertekel(FNevO,K,KDb,Ny);
  writeln('A kirtkels elkszlt (',FNevO,')');
end.
