/* KUPAC.C : Kupacrendezs */

#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define MaxElemSzam 10            /* A rendezend adatok maximlis szma */
#define MaxElem 20                /* A generland adatok maximlis rtke */

typedef int Elem;                   /* A rendezend elemek tpusa */
typedef Elem Tomb[MaxElemSzam+1];   /* A rendezend elemek tmbje */

/* A kupacindexek miatt a tmb 0. elemt nem hasznljuk, 1-tl indexelnk */

/* Az a[l] besllyesztse az a[l+1], a[l+2],..., a[r] elemek kz */
void Sullyeszt(Tomb a, int l, int r)
{ int i,j,vege; Elem x;
  x=a[l]; i=l; j=2*i; vege=0;
  while (j<=r && vege==0) {
    /* A kisebb gyerekkel hasonltsunk */
    if (j<r && a[j+1]<a[j]) j++;
    if (x<=a[j])
      /* Megvan a helye */
      vege=1;
    else {
      /* A gyerek feljebb lptetse */
      a[i]=a[j]; i=j; j=2*i;
    }
  }
  /* Elemet a helyre */
  a[i]=x;
}

void KupacRend(Tomb a, int n)
{ int l,r; Elem x;
  /* Kezdkupac */
  l=n/2+1; r=n;
  while (l>1) {
    l--;
    Sullyeszt(a,l,r);
  }
  while (r>1) {
    /* A legkisebbet htra */
    x=a[1]; a[1]=a[r]; a[r]=x;
    /* A kupacot kisebbre */
    r--;
    /* A htul volt elem besllyesztse */
    Sullyeszt(a,l,r);
  }
}

/* Elemek generlsa */
void General(Tomb a, int n)
{ int i;
  for (i=1; i<=n; i++) a[i]=random(MaxElem+1);
}

void Kiiras(char *Szoveg, Tomb a, int n)
{ int i;
  printf("%s\n",Szoveg);
  for (i=1; i<=n; i++) printf("%d ",a[i]);
  printf("\n");
}

void main(void)
{ Tomb a;
  randomize(); clrscr();

  General(a,MaxElemSzam);
  Kiiras("Rendezs eltt",a,MaxElemSzam);

  /* Sorbarendezs */
  KupacRend(a,MaxElemSzam);

  Kiiras("Rendezs utn",a,MaxElemSzam);
}
