{ Kupacrendezs }
program KUPAC;
uses crt;
const
  MaxElemSzam=10;            { A rendezend adatok maximlis szma }
  MaxElem=20;                { A generland adatok maximlis rtke }
type
  Elem=integer;                         { A rendezend elemek tpusa }
  Tomb=array[1..MaxElemSzam] of Elem;   { A rendezend elemek tmbje }

{ Az a[l] besllyesztse az a[l+1], a[l+2],..., a[r] elemek kz }
procedure Sullyeszt(var a:Tomb; l,r:integer);
var i,j:integer; vege:boolean; x:Elem;
begin
  x:=a[l]; i:=l; j:=2*i; vege:=false;
  while (j<=r) and not vege do begin
    { A kisebb gyerekkel hasonltsunk }
    if (j<r) and (a[j+1]<a[j]) then inc(j);
    if x<=a[j] then
      { Megvan a helye }
      vege:=true
    else begin
      { A gyerek feljebb lptetse }
      a[i]:=a[j]; i:=j; j:=2*i;
    end;
  end;
  { Elemet a helyre }
  a[i]:=x;
end;

procedure KupacRend(var a:Tomb; n:integer);
var l,r:integer; x:Elem;
begin
  { Kezdkupac }
  l:=n div 2+1; r:=n;
  while l>1 do begin
    dec(l);
    Sullyeszt(a,l,r);
  end;
  while r>1 do begin
    { A legkisebbet htra }
    x:=a[1]; a[1]:=a[r]; a[r]:=x;
    { A kupacot kisebbre }
    dec(r);
    { A htul volt elem besllyesztse }
    Sullyeszt(a,l,r);
  end;
end;

{ Elemek generlsa }
procedure General(var a:Tomb; n:integer);
var i:integer;
begin
  for i:=1 to n do
    a[i]:=random(MaxElem+1);
end;

procedure Kiiras(Szoveg:string; const a:Tomb; n:integer);
var i:integer;
begin
  writeln(Szoveg);
  for i:=1 to n do write(a[i],' ');
  writeln;
end;

var a:Tomb;
begin
  randomize; clrscr;

  General(a,MaxElemSzam);
  Kiiras('Rendezs eltt',a,MaxElemSzam);

  { Sorbarendezs }
  KupacRend(a,MaxElemSzam);

  Kiiras('Rendezs utn',a,MaxElemSzam);
end.

