/* LISTAK.C : Egy- s ktirnyban lncolt listk */

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

typedef int Elem;

typedef struct LancElem1 {
  Elem Adat;
  struct LancElem1 *Koveto;
};

typedef struct LancElem1* LancElem1Mut;

struct LancElem2 {
  Elem Adat;
  struct LancElem2 *Elozo, *Koveto;
};
typedef struct LancElem2* LancElem2Mut;

/* Keress egy egyirnyban lncolt, rendezetlen listban */
LancElem1Mut Kereses1(LancElem1Mut Elso, Elem x)
{ LancElem1Mut Akt;
  Akt=Elso;
  while (Akt!=NULL && (*Akt).Adat!=x)
    Akt=(*Akt).Koveto;
  return (Akt);
}

/* Keress egy egyirnyban lncolt, rendezett listban */
LancElem1Mut KeresesRend1(LancElem1Mut Elso, Elem x)
{ LancElem1Mut Akt;
  Akt=Elso;
  while (Akt!=NULL && (*Akt).Adat<x)
    Akt=(*Akt).Koveto;
  if (Akt!=NULL && (*Akt).Adat>x)
    Akt=NULL;
  return (Akt);
}

/* Egy egyirnyban lncolt, rendezett lista bvtse egy j listaelemmel */
void ListaraRend1(LancElem1Mut *Elso, LancElem1Mut Uj)
{ LancElem1Mut Akt,Miutan;
  /* Keress */
  Akt=*Elso; Miutan=NULL;
  while (Akt!=NULL && (*Akt).Adat<(*Uj).Adat) {
    Miutan=Akt;
    Akt=(*Akt).Koveto;
  }
  /* Beilleszts */
  if (*Elso==NULL) {
    /* res listra */
    (*Uj).Koveto=NULL;
    *Elso=Uj;
  } else if (Miutan==NULL) {
    /* Nem res lista elejre */
    (*Uj).Koveto=*Elso;
    *Elso=Uj;
  } else if (Akt==NULL) {
    /* A lista vgre, a Miutan utn */
    (*Uj).Koveto=NULL;
    (*Miutan).Koveto=Uj;
  } else {
    /* A Miutan s az Akt kz */
    (*Uj).Koveto=(*Miutan).Koveto;
    (*Miutan).Koveto=Uj;
  }
}

/* Beilleszts egy ktirnyban lncolt lista vgre */
void Listara2(LancElem2Mut *Elso, LancElem2Mut *Utolso, LancElem2Mut Uj)
{ if (*Elso==NULL) {
    /* res listra */
    (*Uj).Elozo=NULL;
    (*Uj).Koveto=NULL;
    *Elso=Uj;
    *Utolso=Uj;
  } else {
    /* Az Utolso utn */
    (*Uj).Elozo=*Utolso;
    (*Uj).Koveto=NULL;
    (**Utolso).Koveto=Uj;
    *Utolso=Uj;
  }
}

/* Elem trlse egy ktirnyban lncolt listbl */
void Listarol2(LancElem2Mut *Elso, LancElem2Mut *Utolso, LancElem2Mut Mit)
{ /* Kikapcsols */
  if (Mit==*Elso && Mit==*Utolso) {
    /* Egyetlen elem */
    *Elso=NULL;
    *Utolso=NULL;
  } else if (Mit==*Elso) {
    /* Els, de nem egyetlen */
    (*(*Mit).Koveto).Elozo=NULL;
    *Elso=(*Mit).Koveto;
  } else if (Mit==*Utolso) {
    /* Utols, de nem egyetlen */
    (*(*Mit).Elozo).Koveto=NULL;
    *Utolso=(*Mit).Elozo;
  } else {
    /* Bels elem */
    (*(*Mit).Elozo).Koveto=(*Mit).Koveto;
    (*(*Mit).Koveto).Elozo=(*Mit).Elozo;
  }
  /* Megszntets */
  free(Mit);
}

void main()
{ LancElem1Mut Elso1,Akt1;
  LancElem2Mut Elso2,Utolso2,Akt2;
  Elem a; int i;
  clrscr();
  Elso1=NULL;
  printf("Adatmegads vge:0\n"); i=1;
  do {
    printf("%d. elem:",i++); scanf("%d",&a);
    if (a!=0) {
      if ((Akt1=(LancElem1Mut)malloc(sizeof(struct LancElem1)))!=NULL) {
	/* Van hely, a rendezett lncba illesszk */
	(*Akt1).Adat=a;
	ListaraRend1(&Elso1,Akt1);
      }
    }
  } while (a!=0);

  printf("A megadott elemek rendezve:\n");
  for (Akt1=Elso1, i=1; Akt1!=NULL; Akt1=(*Akt1).Koveto, i++)
    printf("%d. elem:%d\n",i,(*Akt1).Adat);

  printf("A keresett elem:"); scanf("%d",&a);
  if (Kereses1(Elso1,a)==NULL)
    printf("Nincs ilyen!\n");
  else
    printf("Van ilyen!\n");
  if (KeresesRend1(Elso1,a)==NULL)
    printf("Nincs ilyen!\n");
  else
    printf("Van ilyen!\n");

  /* A foglalt hely felszabadtsa */
  while (Elso1!=NULL) {
    Akt1=Elso1;
    Elso1=(*Elso1).Koveto;
    free(Akt1);
  }

  Elso2=NULL; Utolso2=NULL;
  printf("Adatmegads vge:0\n"); i=1;
  do {
    printf("%d. elem:",i++); scanf("%d",&a);
    if (a!=0) {
      if ((Akt2=(LancElem2Mut)malloc(sizeof(struct LancElem2)))!=NULL) {
	/* Van hely, a lnc vgre illesszk */
	(*Akt2).Adat=a;
	Listara2(&Elso2,&Utolso2,Akt2);
      }
    }
  } while (a!=0);

  printf("A megadott elemek eredeti sorrendben:\n");
  for (Akt2=Elso2, i=1; Akt2!=NULL; Akt2=(*Akt2).Koveto, i++)
    printf("%d. elem:%d\n",i,(*Akt2).Adat);

  printf("A megadott elemek fordtott sorrendben:\n");
  for (Akt2=Utolso2, i=1; Akt2!=NULL; Akt2=(*Akt2).Elozo, i++)
    printf("%d. elem:%d\n",i,(*Akt2).Adat);

  /* A foglalt hely felszabadtsa (lehetne az utols trlsvel is) */
  while (Elso2!=NULL)
    Listarol2(&Elso2,&Utolso2,Elso2);
}
