/* RENDKER.C : Rendezsek, keressek */

#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define MaxElemSzam 10            /* A rendezend adatok maximlis szma */
#define MaxElem 20                /* A generland adatok maximlis rtke */

typedef int Elem;                        /* A rendezend elemek tpusa */
typedef Elem Tomb[MaxElemSzam];          /* A rendezend elemek tmbje */
typedef int IndexTabla[MaxElemSzam];     /* Az indextbla tpusa */

/* Buborkrendezs */
void BubRend(Tomb a, int n)
{ Elem cs; int i,j;
  for (i=0; i<n-1; i++)
    /* i. elemet a helyre */
    for (j=n-1; j>=i+1; j--)
      if (a[j]<a[j-1]) {
	/* A j. s j-1. elemek cserje */
	cs=a[j]; a[j]=a[j-1]; a[j-1]=cs;
      }
}

/* Rendezs kivlasztssal */
void KivalRend(Tomb a, int n)
{ Elem cs; int i,j,k;
  for (i=0; i<n-1; i++) {
    /* i. elemet a helyre */
    k=i;
    for (j=i+1; j<n; j++)
      if (a[j]<a[k]) k=j;
    if (k>i) {
      /* Az i. s k. elemek cserje */
      cs=a[i]; a[i]=a[k]; a[k]=cs;
    }
  }
}

/* Rendezs kivlasztssal, indextblval */
void KivalRendIt(Tomb a, IndexTabla it, int n)
{ int i,j,k,cs;
  /* Az indextbla feltltse */
  for (i=0; i<n; i++) it[i]=i;
  /* Rendezs */
  for (i=0; i<n-1; i++) {
    /* i. elemet a helyre */
    k=i;
    for (j=i+1; j<n; j++)
      if (a[it[j]]<a[it[k]]) k=j;
    if (k>i) {
      /* Az i. s k. indexek cserje */
      cs=it[i]; it[i]=it[k]; it[k]=cs;
    }
  }
}

/* Rendezs beszrssal */
void BeszurRend(Tomb a, int n)
{ Elem x; int i,j;
  for (i=1; i<n; i++) {
    /* Az i. elem beszrsa az eltte lv rendezett rszbe */
    x=a[i];
    /* Helykszts htralptetssel */
    j=i-1;
    while (j>=0 && a[j]>x) {
      a[j+1]=a[j]; j--;
    }
    /* i. elemet a helyre */
    a[j+1]=x;
  }
}

/* Lineris keress rendezetlen adatok kztt */
int LinKer(Tomb a, int n, Elem x, int *Hol)
{ int i,Van;
  i=0;
  while (i<n && a[i]!=x) i++;
  if (i<n) {
    Van=1;
    *Hol=i;
  } else Van=0;
  return (Van);
}

/* Lineris keress rendezett adatok kztt */
int LinKerRend(Tomb a, int n, Elem x, int *Hol)
{ int i,Van;
  i=0;
  while (i<n && a[i]<x) i++;
  Van=i<n && a[i]==x;
  *Hol=i;
  return (Van);
}

/* Binris keress */
int BinKer(Tomb a, int n, Elem x, int *Hol)
{ int i,j,k,Van;
  i=0; j=n-1; Van=0;
  while (i<=j && !Van) {
    k=(i+j)/2;
    if (a[k]==x) Van=1;
    else
      if (x<a[k]) j=k-1;
      else i=k+1;
  }
  if (Van) *Hol=k;
  else *Hol=i;
  return (Van);
}

/* Binris keress indextblval */
int BinKerIt(Tomb a, IndexTabla it, int n, Elem x, int *Hol)
{ int i,j,k,Van;
  i=0; j=n-1; Van=0;
  while (i<=j && !Van) {
    k=(i+j)/2;
    if (a[it[k]]==x) Van=1;
    else
      if (x<a[it[k]]) j=k-1;
      else i=k+1;
  }
  if (Van) *Hol=k;
  else *Hol=i;
  return (Van);
}

/* Elemek generlsa */
void General(Tomb a, int n)
{ int i;
  for (i=0; i<n; i++) a[i]=random(MaxElem+1);
}

/* Elemek tttele Mibol Mibe */
void Attesz(Tomb Mibol, Tomb Mibe, int n)
{ int i;
  for (i=0; i<n; i++) Mibe[i]=Mibol[i];
}

void Kiiras(char *Szoveg, Tomb a, int n)
{ int i;
  printf("%s\n",Szoveg);
  for (i=0; i<n; i++) printf("%d ",a[i]);
  printf("\n");
}

void KiirasIt(char *Szoveg, Tomb a, IndexTabla it, int n)
{ int i;
  printf("%s\n",Szoveg);
  for (i=0; i<n; i++) printf("%d ",a[it[i]]);
  printf("\n");
}

void main(void)
{ Tomb a,b; IndexTabla it; Elem x; int Hol;
  randomize(); clrscr();

  General(b,MaxElemSzam);
  Kiiras("Rendezsek eltt",b,MaxElemSzam);

  Attesz(b,a,MaxElemSzam);
  BubRend(a,MaxElemSzam);
  Kiiras("Bubork rendezs utn",a,MaxElemSzam);

  Attesz(b,a,MaxElemSzam);
  KivalRend(a,MaxElemSzam);
  Kiiras("Kivlasztsos rendezs utn",a,MaxElemSzam);

  Attesz(b,a,MaxElemSzam);
  BeszurRend(a,MaxElemSzam);
  Kiiras("Beszrsos rendezs utn",a,MaxElemSzam);

  KivalRendIt(b,it,MaxElemSzam);
  KiirasIt("Egy indextbls rendezs utn",b,it,MaxElemSzam);

  printf("Mit keressnk:"); scanf("%d",&x);
  if (LinKer(b,MaxElemSzam,x,&Hol))
    printf("A rendezetlen adatok kztti indexe:%d\n",Hol);
  else
    printf("Nincs a rendezetlen adatok kztt!\n");
  if (LinKerRend(a,MaxElemSzam,x,&Hol))
    printf("A rendezett adatok kztti indexe:%d\n",Hol);
  else
    printf("Nincs a rendezett adatok kztt, helye:%d\n",Hol);
  if (BinKer(a,MaxElemSzam,x,&Hol))
    printf("A rendezett adatok kztti indexe:%d\n",Hol);
  else
    printf("Nincs a rendezett adatok kztt, helye:%d\n",Hol);
  if (BinKerIt(b,it,MaxElemSzam,x,&Hol))
    printf("Indextblabeli indexe:%d\n",Hol);
  else
    printf("Indextblabeli helye:%d\n",Hol);
}
