{ Rendezsek, keressek }
program RENDKER;
uses crt;
const
  MaxElemSzam=10;            { A rendezend adatok maximlis szma }
  MaxElem=20;                { A generland adatok maximlis rtke }
type
  Elem=integer;                               { A rendezend elemek tpusa }
  Index=1..MaxElemSzam;                       { Az indexek tpusa }
  Tomb=array[Index] of Elem;                  { A rendezend elemek tmbje }
  IndexTabla=array[Index] of Index;           { Az indextbla tpusa }

{ Buborkrendezs }
procedure BubRend(var a:Tomb; n:integer);
var cs:Elem; i,j:integer;
begin
  for i:=1 to n-1 do
    { i. elemet a helyre }
    for j:=n downto i+1 do
      if a[j]<a[j-1] then begin
	{ A j. s j-1. elemek cserje }
	cs:=a[j]; a[j]:=a[j-1]; a[j-1]:=cs;
      end;
end;

{ Rendezs kivlasztssal }
procedure KivalRend(var a:Tomb; n:integer);
var cs:Elem; i,j,k:integer;
begin
  for i:=1 to n-1 do begin
    { i. elemet a helyre }
    k:=i;
    for j:=i+1 to n do
      if a[j]<a[k] then k:=j;
    if k>i then begin
      { Az i. s k. elemek cserje }
      cs:=a[i]; a[i]:=a[k]; a[k]:=cs;
    end;
  end;
end;

{ Rendezs kivlasztssal, indextblval }
procedure KivalRendIt(var a:Tomb; var it:IndexTabla; n:integer);
var i,j,k,cs:integer;
begin
  { Az indextbla feltltse }
  for i:=1 to n do it[i]:=i;
  { Rendezs }
  for i:=1 to n-1 do begin
    { i. elemet a helyre }
    k:=i;
    for j:=i+1 to n do
      if a[it[j]]<a[it[k]] then k:=j;
    if k>i then begin
      { Az i. s k. indexek cserje }
      cs:=it[i]; it[i]:=it[k]; it[k]:=cs;
    end;
  end;
end;

{ Rendezs beszrssal }
procedure BeszurRend(var a:Tomb; n:integer);
var x:Elem; i,j:integer;
begin
  for i:=2 to n do begin
    { Az i. elem beszrsa az eltte lv rendezett rszbe }
    x:=a[i];
    { Helykszts htralptetssel }
    j:=i-1;
    while (j>=1) and (a[j]>x) do begin
      a[j+1]:=a[j]; dec(j);
    end;
    { i. elemet a helyre }
    a[j+1]:=x;
  end;
end;

{ Lineris keress rendezetlen adatok kztt }
function LinKer(const a:Tomb; n:integer; x:Elem; var Hol:integer):boolean;
var i:integer; Van:boolean;
begin
  i:=1;
  while (i<=n) and (a[i]<>x) do inc(i);
  Van:=i<=n;
  if Van then Hol:=i;
  LinKer:=Van;
end;

{ Lineris keress rendezett adatok kztt }
function LinKerRend(const a:Tomb; n:integer; x:Elem; var Hol:integer):boolean;
var i:integer; Van:boolean;
begin
  i:=1;
  while (i<=n) and (a[i]<x) do inc(i);
  Van:=(i<=n) and (a[i]=x);
  Hol:=i;
  LinKerRend:=Van;
end;

{ Binris keress }
function BinKer(const a:Tomb; n:integer; x:Elem; var Hol:integer):boolean;
var i,j,k:integer; Van:boolean;
begin
  i:=1; j:=n; Van:=false;
  while (i<=j) and not Van do begin
    k:=(i+j) div 2;
    if a[k]=x then Van:=true
    else
      if x<a[k] then j:=k-1
      else i:=k+1;
  end;
  if Van then Hol:=k
  else Hol:=i;
  BinKer:=Van;
end;

{ Binris keress indextblval }
function BinKerIt(const a:Tomb; const it:IndexTabla; n:integer;
 x:Elem; var Hol:integer):boolean;
var i,j,k:integer; Van:boolean;
begin
  i:=1; j:=n; Van:=false;
  while (i<=j) and not Van do begin
    k:=(i+j) div 2;
    if a[it[k]]=x then Van:=true
    else
      if x<a[it[k]] then j:=k-1
      else i:=k+1;
  end;
  if Van then Hol:=k
  else Hol:=i;
  BinKerIt:=Van;
end;

{ Elemek generlsa }
procedure General(var a:Tomb; n:integer);
var i:integer;
begin
  for i:=1 to n do
    a[i]:=random(MaxElem+1);
end;

procedure Kiiras(Szoveg:string; const a:Tomb; n:integer);
var i:integer;
begin
  writeln(Szoveg);
  for i:=1 to n do write(a[i],' ');
  writeln;
end;

procedure KiirasIt(Szoveg:string; const a:Tomb;
 const it:IndexTabla; n:integer);
var i:integer;
begin
  writeln(Szoveg);
  for i:=1 to n do write(a[it[i]],' ');
  writeln;
end;

var a,b:Tomb; it:IndexTabla; x:Elem; Hol:integer;
begin
  randomize; clrscr;

  General(b,MaxElemSzam);
  Kiiras('Rendezsek eltt',b,MaxElemSzam);

  a:=b;
  BubRend(a,MaxElemSzam);
  Kiiras('Bubork rendezs utn',a,MaxElemSzam);

  a:=b;
  KivalRend(a,MaxElemSzam);
  Kiiras('Kivlasztsos rendezs utn',a,MaxElemSzam);

  a:=b;
  BeszurRend(a,MaxElemSzam);
  Kiiras('Beszrsos rendezs utn',a,MaxElemSzam);

  KivalRendIt(b,it,MaxElemSzam);
  KiirasIt('Egy indextbls rendezs utn',b,it,MaxElemSzam);

  write('Mit keressnk:'); readln(x);
  if LinKer(b,MaxElemSzam,x,Hol) then
    writeln('A rendezetlen adatok kztti indexe:',Hol)
  else
    writeln('Nincs a rendezetlen adatok kztt!');
  if LinKerRend(a,MaxElemSzam,x,Hol) then
    writeln('A rendezett adatok kztti indexe:',Hol)
  else
    writeln('Nincs a rendezett adatok kztt, helye:',Hol);
  if BinKer(a,MaxElemSzam,x,Hol) then
    writeln('A rendezett adatok kztti indexe:',Hol)
  else
    writeln('Nincs a rendezett adatok kztt, helye:',Hol);
  if BinKerIt(b,it,MaxElemSzam,x,Hol) then
    writeln('Indextblabeli indexe:',Hol)
  else
    writeln('Indextblabeli helye:',Hol);
end.
