/* TARGYMUT.C : Trgymutat */

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>

#define MaxSzoHossz 20                    /* A szavak maximlis hossza */

typedef char TSzo[MaxSzoHossz+1];         /* A szavak tpusa */
typedef unsigned int THiv;                /* A hivatkozsok tpusa */

struct HivRek {                           /* A hivatkozsrekord */
  THiv Oldal;
  struct HivRek *Kov;
};
typedef struct HivRek * HivRekMut;        /* A hivatkozsrekordra mutat */

struct SzoRek {                           /* A szrekord */
  TSzo Szo;
  struct HivRek *EHiv,*UHiv;
  struct SzoRek *Kov;
};
typedef struct SzoRek * SzoRekMut;        /* A szrekordra mutat */

/* j szrekord ltrehozsa */
SzoRekMut UjSzoRek(TSzo Szo, THiv Oldal, SzoRekMut KovSzo)
{ SzoRekMut UjSzo; HivRekMut UjHiv;
  UjSzo=(SzoRekMut)malloc(sizeof(struct SzoRek));
  strcpy((*UjSzo).Szo,Szo);
  (*UjSzo).Kov=KovSzo;
  UjHiv=(HivRekMut)malloc(sizeof(struct HivRek));
  (*UjSzo).EHiv=UjHiv;
  (*UjSzo).UHiv=UjHiv;
  (*UjHiv).Oldal=Oldal;
  (*UjHiv).Kov=NULL;
  return (UjSzo);
}

/* A trgymutat bvtse */
void Bovit(SzoRekMut *TMKezd, TSzo Szo, THiv Oldal)
{ SzoRekMut Akt,Elozo; HivRekMut UjHiv;
  if (*TMKezd==NULL)
    /* res a trgymutat */
    *TMKezd=UjSzoRek(Szo,Oldal,NULL);
  else {
    /* Keress */
    Akt=*TMKezd;
    Elozo=NULL;
    while (strcmp((*Akt).Szo,Szo)<0 && (*Akt).Kov!=NULL) {
      Elozo=Akt;
      Akt=(*Akt).Kov;
    }
    if (strcmp((*Akt).Szo,Szo)<0)
      /* Vgre j sz */
      (*Akt).Kov=UjSzoRek(Szo,Oldal,NULL);
    else if (strcmp((*Akt).Szo,Szo)>0)
      /* Az Akt s az Elozo kz j sz */
      if (Elozo==NULL)
	/* A lista elejre */
	*TMKezd=UjSzoRek(Szo,Oldal,*TMKezd);
      else
	/* A lista belsejbe */
	(*Elozo).Kov=UjSzoRek(Szo,Oldal,Akt);
    else {
      /* Meglv sz (Akt) j hivatkozsa */
      UjHiv=(HivRekMut)malloc(sizeof(struct HivRek));
      (*UjHiv).Oldal=Oldal;
      (*UjHiv).Kov=NULL;
      (*(*Akt).UHiv).Kov=UjHiv;
      (*Akt).UHiv=UjHiv;
    }
  }
}

/* A trgymutat adatainak kirsa a kpernyre */
void Kiir(SzoRekMut TMKezd)
{ SzoRekMut Akt; HivRekMut AktHiv;
  Akt=TMKezd;
  while (Akt!=NULL) {
    printf("%-20s",(*Akt).Szo);
    AktHiv=(*Akt).EHiv;
    while (AktHiv!=NULL) {
      printf("%6d",(*AktHiv).Oldal);
      AktHiv=(*AktHiv).Kov;
    };
    printf("\n"); getch();
    Akt=(*Akt).Kov;
  }
}

void main()
{ SzoRekMut TMKezd; int VanHely,Vege;
  HivRekMut H; SzoRekMut Sz; TSzo Szo; THiv Hiv;
  clrscr();
  TMKezd=NULL;
  /* Feltlts input adatokkal */
  printf("A trgymutat adatai (Kilps:'*' sz)\n");
  do {
    /* Lesz majd elg hely? */
    Sz=(SzoRekMut)malloc(sizeof(struct SzoRek));
    H=(HivRekMut)malloc(sizeof(struct HivRek));
    VanHely=(Sz!=NULL) && (H!=NULL);
    if (VanHely) {
      /* Igen */
      free(H); free(Sz);
      printf("Sz:"); scanf("%s",&Szo);
      Vege=strcmp(Szo,"*")==0;
      if (!Vege) {
	printf("Hivatkozs:"); scanf("%d",&Hiv);
	Bovit(&TMKezd,Szo,Hiv);
      }
    }
  } while (!Vege && VanHely);
  /* Kirs */
  if (TMKezd==NULL)
    printf("Nem adott meg adatokat!\n");
  else {
    printf("A trgymutat:\n");
    Kiir(TMKezd);
  }
}
