/* TIPFINDT.C : Tpusos fjl kezelse indextblval */

#include <stdio.h>
#include <conio.h>
#include <string.h>

/* Fjlnevek */
char *afnev="adatc.dat";          /* Adatfjl */
char *ifnev="adatc.ind";          /* Indextbla */

#define MaxDb 5             /* Az adatok maximlis szma */
#define MaxAzHossz 1        /* Az azonost maximlis hossza */
#define MaxInfoHossz 3      /* Az informci maximlis hossza */

char *UresAz=" ";           /* Az res azonost */

/* +1: a vgjelnek */
typedef char TAz[MaxAzHossz+1];       /* Az adatrekord azonost tpusa */
typedef char TInfo[MaxInfoHossz+1];   /* Az adatrekord informci tpusa */

typedef struct {            /* Az adatrekord tpusa */
  TAz Az;
  TInfo Info;
} TAdat;

typedef struct {            /* Az indextbla egy elemnek tpusa */
  TAz Az;                   /* Ez alapjn indexeznk */
  int Poz;                  /* A rekord pozcija az adatfjlban */
} TItAdat;

/* Az indextbla tpusa */
/* A 0. rekord Poz rtke az adatfile rvnyes rekordjainak szma */
typedef TItAdat TIt[MaxDb+1];

/* Binris keress az indextblban */
int BinKer(TAz Mit, TIt Miben, int Db, int *Hol)
{ int i,j,k,l,Van;
  i=1; j=Db; Van=0;
  while (i<=j && !Van) {
    k=(i+j)/2; l=strcmp(Mit,Miben[k].Az);
    if (l==0) Van=1;
    else
      if (l<0) j=k-1;
      else i=k+1;
  }
  if (Van) *Hol=k;
  else *Hol=i;
  return (Van);
}

/* Beszrs az indextblba */
void Beszur(TItAdat *Mit, TIt *Mibe, int Hova, int *Db)
{ int i;
  /* Helykszts */
  for (i=*Db; i>=Hova; i--)
    (*Mibe)[i+1]=(*Mibe)[i];
  /* Beszrs */
  (*Mibe)[Hova]=*Mit;
  /* Darabszm nvels */
  (*Db)++;
}

/* Trls az indextblbl */
void Torol(TIt *Mibol, int Honnan, int *Db)
{ int i; TItAdat s;
  /* A trlend elem megjegyzse */
  s=(*Mibol)[Honnan];
  /* Trls */
  for (i=Honnan+1; i<=*Db; i++)
    (*Mibol)[i-1]=(*Mibol)[i];
  /* Hogy a fjlba majd ennek helyre vegynk fel legkzelebb */
  (*Mibol)[*Db]=s;
  /* Darabszm cskkents */
  (*Db)--;
  if (Db==0)
    /* Az elejrl tltsk fel az adatfjlt */
    for (i=1; i<=MaxDb; i++)
      ((*Mibol)[i]).Poz=i-1;
}

/* Elem felvtel */
void Felvetel(TIt *Mibe, int *Db, FILE *af)
{ int Hol;
  TAdat Adat; TItAdat ItAdat;
  if (*Db==MaxDb)
    printf("Nem vehet fel tbb elem!");
  else {
    printf("Azonost (max %d karakter):",MaxAzHossz);
    scanf("%s",&Adat.Az);
    if (BinKer(Adat.Az,*Mibe,*Db,&Hol)==1)
      printf("Van mr ilyen azonostj rekord!");
    else {
      printf("Informci (max %d karakter):",MaxInfoHossz);
      scanf("%s",&Adat.Info);
      /* Bers az adatfjlba */
      fseek(af,((*Mibe)[*Db+1]).Poz*sizeof(TAdat),SEEK_SET);
      fwrite(&Adat,sizeof(TAdat),1,af);
      /* Felvtel az indextblba */
      strcpy(ItAdat.Az,Adat.Az); ItAdat.Poz=((*Mibe)[*Db+1]).Poz;
      Beszur(&ItAdat,Mibe,Hol,Db);
    }
  }
}

/* Elem trls */
void Torles(TIt *Mibol, int *Db)
{ TAz Mit; int Hol;
  if (*Db==0)
    printf("Nincs mit trlni!");
  else {
    printf("Azonost (max %d karakter):",MaxAzHossz);
    scanf("%s",&Mit);
    if (BinKer(Mit,*Mibol,*Db,&Hol)==0)
      printf("Nincs ilyen rekord!");
    else
      Torol(Mibol,Hol,Db);
  }
}

void Kiir(int x, int y, char *Mit)
{ gotoxy(x,y);
  printf("%s",Mit);
}

/* Adatok kirsa */
void Kiiras(TIt it, FILE *af)
{ int i; TAdat Adat;
  clrscr();
  /* Fejlc 12345678901234567890123456 */
  Kiir(1,1,"Ssz  Indextbla  Adatfjl");
  Kiir(1,2,"     Az- Poz    Az- Info");
  /* Indextbla */
  for (i=0; i<=MaxDb; i++) {
    gotoxy(2,4+i); printf("%d.",i);
    if (i<=it[0].Poz)
      Kiir(6,4+i,it[i].Az);
    else
      Kiir(6,4+i,UresAz);
    gotoxy(11,4+i); printf("%d",it[i].Poz);
  }
  /* Adatfjl */
  fseek(af,0L,SEEK_SET); i=0;
  while (fread(&Adat,sizeof(TAdat),1,af)==1) {
    Kiir(18,4+i,Adat.Az);
    Kiir(23,4+i,Adat.Info);
    i++;
  }
  gotoxy(1,4+MaxDb+2); printf("Elemek szma:%d\n",it[0].Poz);
}

/* Fjl ltezsnek vizsglata */
int FajlVan(const char *Nev)
{ FILE *fp; int Er;
  fp=fopen(Nev,"r");
  if (fp==NULL)
    Er=0;
  else {
    fclose(fp);
    Er=1;
  }
  return (Er);
}

void main()
{ FILE *af,*itf;
  TIt it;
  int i;
  clrscr();
  if (FajlVan(afnev)==1 && FajlVan(ifnev)==1) {
    af=fopen(afnev,"rb+");
    /* Az indextbla betltse */
    itf=fopen(ifnev,"rb");
    fread(&it,sizeof(TItAdat),MaxDb+1,itf);
    fclose(itf);
  } else {
    af=fopen(afnev,"wb+");
    /* Indextbla inicializls */
    for (i=0; i<=MaxDb; i++) {
      strcpy(it[i].Az,UresAz);
      if (i==0) it[i].Poz=0;      /* A ltez adatok szma */
      else it[i].Poz=i-1;         /* A leend rekordsorszmok */
    }
  }
  /* Kilpsig */
  do {
    printf("\nFelvtel:1 Trls:2 Kirs:3 Kilps:0\n");
    do {
      i=getch();
    } while (i<'0' || i>'3');
    if (i=='1')
      Felvetel(&it,&it[0].Poz,af);
    else if (i=='2')
      Torles(&it,&it[0].Poz);
    else if (i=='3')
      Kiiras(it,af);
  } while (i!='0');
  fclose(af);
  /* Az indextbla mentse */
  itf=fopen(ifnev,"wb");
  fwrite(&it,sizeof(TItAdat),MaxDb+1,itf);
  fclose(itf);
}
