{ Tpusos fjl kezelse indextblval }
program TIPFINDT;
uses crt;
const
  { Fjlnevek }
  afnev='adatp.dat';           { Adatfjl }
  ifnev='adatp.ind';           { Indextbla }

  MaxDb=5;                     { Az adatok maximlis szma }
  MaxAzHossz=1;                { Az azonost maximlis hossza }
  MaxInfoHossz=3;              { Az informci maximlis hossza }
  UresAz=' ';                  { Az res azonost }
type
  TAz=string[MaxAzHossz];      { Az adatrekord azonost tpusa }
  TInfo=string[MaxInfoHossz];  { Az adatrekord informci tpusa }

  TAdat=record                 { Az adatrekord tpusa }
    Az:TAz;
    Info:TInfo;
  end;

  TItAdat=record               { Az indextbla egy elemnek tpusa }
    Az:TAz;                    { Ez alapjn indexeznk }
    Poz:integer;               { A rekord pozcija az adatfjlban }
  end;

  { Az indextbla tpusa }
  { A 0. rekord Poz rtke az adatfile rvnyes rekordjainak szma }
  TIt=array[0..MaxDb] of TItAdat;
  { Az adatfjl tipusa }
  AdatFajl=file of TAdat;
  { Az indexfjl tipusa }
  IndexFajl=file of TIt;

{ Binris keress az indextblban }
function BinKer(Mit:TAz; const Miben:TIt; Db:integer;
 var Hol:integer):boolean;
var i,j,k:integer; Van:boolean;
begin
  i:=1; j:=Db; Van:=false;
  while (i<=j) and not Van do begin
    k:=(i+j) div 2;
    if Mit=Miben[k].Az then Van:=true
    else
      if Mit<Miben[k].Az then j:=k-1
      else i:=k+1;
   end;
  if Van then Hol:=k
  else Hol:=i;
  BinKer:=Van;
end;

{ Beszrs az indextblba }
procedure Beszur(const Mit:TItAdat; var Mibe:TIt;
 Hova:integer; var Db:integer);
var i:integer;
begin
  { Helykszts }
  for i:=Db downto Hova do
    Mibe[i+1]:=Mibe[i];
  { Beszrs }
  Mibe[Hova]:=Mit;
  { Darabszm nvels }
  inc(Db);
end;

{ Trls az indextblbl }
procedure Torol(var Mibol:TIt; Honnan:integer; var Db:integer);
var i:integer; s:TItAdat;
begin
  { A trlend elem megjegyzse }
  s:=Mibol[Honnan];
  { Trls }
  for i:=Honnan+1 to Db do
    Mibol[i-1]:=Mibol[i];
  { Hogy a fjlba majd ennek helyre vegynk fel legkzelebb }
  Mibol[Db]:=s;
  { Darabszm cskkents }
  dec(Db);
  if Db=0 then
    { Az elejrl tltsk fel az adatfjlt }
    for i:=1 to MaxDb do
      Mibol[i].Poz:=i-1;
end;

{ Elem felvtel }
procedure Felvetel(var Mibe:TIt; var Db:integer; var af:AdatFajl);
var Hol:integer;
    Adat:TAdat; ItAdat:TItAdat;
begin
  if Db=MaxDb then
    writeln('Nem vehet fel tbb elem!')
  else with Adat do begin
    write('Azonost (max ',MaxAzHossz,' karakter):');
    readln(Az);
    if BinKer(Az,Mibe,Db,Hol) then
      writeln('Van mr ilyen azonostj rekord!')
    else begin
      write('Informci (max ',MaxInfoHossz,' karakter):');
      readln(Info);
      { Bers az adatfjlba }
      seek(af,Mibe[Db+1].Poz);
      write(af,Adat);
      { Felvtel az indextblba }
      ItAdat.Az:=Adat.Az; ItAdat.Poz:=Mibe[Db+1].Poz;
      Beszur(ItAdat,Mibe,Hol,Db);
    end;
  end;
end;

{ Elem trls }
procedure Torles(var Mibol:TIt; var Db:integer);
var Mit:TAz; Hol:integer;
begin
  if db=0 then
    writeln('Nincs mit trlni!')
  else begin
    write('Azonost (max ',MaxAzHossz,' karakter):');
    readln(Mit);
    if not BinKer(Mit,Mibol,Db,Hol) then
      writeln('Nincs ilyen rekord!')
    else
      Torol(Mibol,Hol,Db);
  end;
end;

procedure Kiir(x,y:integer; Mit:string);
begin
  gotoxy(x,y); write(Mit);
end;

{ Adatok kirsa }
procedure Kiiras(const it:TIt; var af:AdatFajl);
var i:integer; Adat:TAdat;
begin
  clrscr;
  { Fejlc  12345678901234567890123456 }
  Kiir(1,1,'Ssz  Indextbla  Adatfjl');
  Kiir(1,2,'     Az- Poz    Az- Info');
  { Indextbla }
  for i:=0 to MaxDb do begin
    gotoxy(2,4+i); write(i,'.');
    if i<=it[0].Poz then
      Kiir(6,4+i,it[i].Az)
    else
      Kiir(6,4+i,UresAz);
    gotoxy(11,4+i); write(it[i].Poz);
  end;
  { Adatfjl }
  seek(af,0); i:=0;
  while not eof(af) do begin
    read(af,Adat);
    Kiir(18,4+i,Adat.Az);
    Kiir(23,4+i,Adat.Info);
    inc(i);
  end;
  gotoxy(1,4+MaxDb+2); writeln('Elemek szma:',it[0].Poz);
end;

{ Fjl ltezsnek vizsglata }
function FajlVan(Nev:string):boolean;
var f:file; Er:boolean;
begin
  if Nev='' then Er:=false
  else begin
    assign(f,Nev);
    {$i-} reset(f); {$i+}
    if ioresult=0 then begin
      Er:=true; close(f);
    end else Er:=false;
  end;
  FajlVan:=Er;
end;

var af:AdatFajl; itf:IndexFajl;
    it:TIt; i:integer; c:char;
begin
  clrscr;
  assign(af,afnev); assign(itf,ifnev);
  if FajlVan(afnev) and FajlVan(ifnev) then begin
    reset(af);
    { Az indextbla betltse }
    reset(itf); read(itf,it); close(itf);
  end else begin
    rewrite(af);
    { Indextbla inicializls }
    for i:=0 to MaxDb do begin
      it[i].Az:=UresAz;
      if i=0 then it[i].Poz:=0     { A ltez adatok szma }
      else it[i].Poz:=i-1;         { A leend rekordsorszmok }
    end;
  end;
  { Kilpsig }
  repeat
    writeln; writeln('Felvtel:1 Trls:2 Kirs:3 Kilps:0');
    repeat c:=readkey; until c in ['0'..'3'];
    case c of
      '1':Felvetel(it,it[0].Poz,af);
      '2':Torles(it,it[0].Poz);
      '3':Kiiras(it,af);
    end;
  until c='0';
  close(af);
  { Az indextbla mentse }
  rewrite(itf); write(itf,it); close(itf);
end.
