/* TIPFREND.C : Tpusos fjl rekordjainak rendezse sszefslssel */

#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <time.h>

char *fnev1="adatokc1.dta";    /* A rendezend adatok */
char *fnev2="adatokc2.dta";    /* Segdfjl */
char *fnev3="adatokc3.dta";    /* Segdfjl */

#define MaxElemSzam 10     /* A generlt adatok maximlis szma */
#define MaxElem 20         /* A generlt adatok maximlis rtke */

typedef struct {           /* A rendezend rekordok */
  int A;                   /* Ezen mez szerint rendeznk */
} TAdat;

/* A fjlmutatt egy rekorddal vissza */
void Vissza(FILE *fp)
{ fseek(fp,(ftell(fp)/sizeof(TAdat)-1)*sizeof(TAdat),SEEK_SET);
}

/* Fjlvgn llunk-e */
int FajlVege(FILE *fp)
{ long pos,meret;
  pos=ftell(fp);
  fseek(fp,0L,SEEK_END);
  meret=ftell(fp);
  fseek(fp,pos,SEEK_SET);
  return (pos==meret);
}

int LancVege(FILE *Miben, TAdat *Akt)
{ TAdat Kov; int Er; long pos;
  if (FajlVege(Miben))
    Er=1;
  else {
    fgetpos(Miben,&pos);
    fread(&Kov,sizeof(TAdat),1,Miben);
    fsetpos(Miben,&pos);
    Er=Kov.A<(*Akt).A;
  }
  return (Er);
}

void LancMasol(FILE *Bol, FILE *Ba)
{ TAdat Akt;
  do {
    fread(&Akt,sizeof(TAdat),1,Bol);
    fwrite(&Akt,sizeof(TAdat),1,Ba);
  } while (!LancVege(Bol,&Akt));
}

void Rendezes(void)
{ FILE *a,*b,*c;
  int LancDb,LancVeg;
  TAdat akt_a,akt_b;
  do {
    /* Sztoszts */
    c=fopen(fnev1,"rb");
    a=fopen(fnev2,"wb");
    b=fopen(fnev3,"wb");
    while (!FajlVege(c)) {
      LancMasol(c,a);
      if (!FajlVege(c))
	LancMasol(c,b);
    };
    fclose(a); fclose(b); fclose(c);
    /* sszefsls */
    c=fopen(fnev1,"wb");
    a=fopen(fnev2,"rb");
    b=fopen(fnev3,"rb");
    LancDb=0;
    while (!FajlVege(a) && !FajlVege(b)) {
      /* Egy lnc sszefslse */
      fread(&akt_a,sizeof(TAdat),1,a);
      fread(&akt_b,sizeof(TAdat),1,b);
      do {
	if (akt_a.A<=akt_b.A) {
	  /* a-bl egy elemet */
	  fwrite(&akt_a,sizeof(TAdat),1,c);
	  LancVeg=LancVege(a,&akt_a);
	  if (LancVeg) {
	    Vissza(b);
	    LancMasol(b,c);
	  } else
	    fread(&akt_a,sizeof(TAdat),1,a);
	} else {
	  /* b-bl egy elemet */
	  fwrite(&akt_b,sizeof(TAdat),1,c);
	  LancVeg=LancVege(b,&akt_b);
	  if (LancVeg) {
	    Vissza(a);
	    LancMasol(a,c);
	  } else
	    fread(&akt_b,sizeof(TAdat),1,b);
	}
      } while (!LancVeg);
      LancDb++;
    };
    /* Maradkok msolsa */
    if (!FajlVege(a)) {
      while (!FajlVege(a)) {
	fread(&akt_a,sizeof(TAdat),1,a);
	fwrite(&akt_a,sizeof(TAdat),1,c);
      };
      LancDb++;
    };
    if (!FajlVege(b)) {
      while (!FajlVege(b)) {
	fread(&akt_b,sizeof(TAdat),1,b);
	fwrite(&akt_b,sizeof(TAdat),1,c);
      };
      LancDb++;
    };
    fclose(a); fclose(b); fclose(c);
  } while (LancDb>1);
}

void main(void)
{ FILE *fp;
  TAdat Adat;
  int i;

  /* Vletlen elemgenerls */
  randomize(); clrscr();
  printf("Rendezs eltt\n");
  fp=fopen(fnev1,"wb");
  for (i=0; i<MaxElemSzam; i++) {
    Adat.A=random(MaxElem+1);
    fwrite(&Adat,sizeof(TAdat),1,fp);
    printf("%d ",Adat.A);
  }; printf("\n");
  fclose(fp);

  /* Sorbarendezs */
  Rendezes();

  /* Eredmnykirs */
  printf("Rendezs utn\n");
  fp=fopen(fnev1,"rb");
  while (!FajlVege(fp)) {
    fread(&Adat,sizeof(TAdat),1,fp);
    printf("%d ",Adat.A);
  }; printf("\n");
  fclose(fp);

  /* Munkafjlok trlse */
  remove(fnev2); remove(fnev3);
}
